/*
 * Created on 2004/05/30
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package HomeWork;

import org.boxed_economy.besp.model.fmfw.behavior.AbstractBehavior;

import org.boxed_economy.besp.model.fmfw.behavior.CompositeState;
import org.boxed_economy.besp.model.fmfw.behavior.State;
import org.boxed_economy.besp.model.fmfw.behavior.StateMachineFactory;
import org.boxed_economy.besp.model.fmfw.behavior.Transition;

import org.boxed_economy.besp.model.fmfw.ChannelEvent;
import org.boxed_economy.besp.model.fmfw.behavior.Action;

import org.boxed_economy.besp.model.fmfw.behavior.Event;
import org.boxed_economy.besp.model.fmfw.behavior.GuardCondition;

/**
* AbstractGambleBehavior
*/
public abstract class AbstractGambleBehavior extends AbstractBehavior {

	/**
	* This method automatically generated from Boxed Economy Behavior Editor.
	* Don't modify this method.
	*/
	protected void initializeStateMachine() {
		//factory
		StateMachineFactory factory = this.getStateMachine();

		//states
		State initialState = factory.createInitialState();
		CompositeState wating_For_StratAnnouncement =
			factory.createCompositeState("Wating For StratAnnouncement");
		CompositeState wating_For_4thCornerAnnouncement =
			factory.createCompositeState("Wating For 4thCornerAnnouncement");
		CompositeState wating_For_ClimaxAnnouncement =
			factory.createCompositeState("Wating For ClimaxAnnouncement");
		CompositeState wating_For_GoalAnnouncement =
			factory.createCompositeState("Wating For GoalAnnouncement");

		//actions
		Action sayingClimaxEmotion = new Action() {
			public void doAction() {
				sayingClimaxEmotion();
			}
			public String toString() {
				return "sayingClimaxEmotion";
			}
		};
		Action saying4thCornerEmotion = new Action() {
			public void doAction() {
				saying4thCornerEmotion();
			}
			public String toString() {
				return "saying4thCornerEmotion";
			}
		};
		Action sayingGoalEmotion = new Action() {
			public void doAction() {
				sayingGoalEmotion();
			}
			public String toString() {
				return "sayingGoalEmotion";
			}
		};
		Action sayingStartEmotionAction = new Action() {
			public void doAction() {
				sayingStartEmotionAction();
			}
			public String toString() {
				return "sayingStartEmotionAction";
			}
		};

		//guard-conditions
		GuardCondition is4thCornerRanking = new GuardCondition() {
			public boolean isMatched(Event e) {
				return is4thCornerRanking(e);
			}
		};
		GuardCondition isGoalRanking = new GuardCondition() {
			public boolean isMatched(Event e) {
				return isGoalRanking(e);
			}
		};
		GuardCondition isClimaxRanking = new GuardCondition() {
			public boolean isMatched(Event e) {
				return isClimaxRanking(e);
			}
		};

		//transitions
		Transition transitionWating_For_StratAnnouncementToWating_For_4thCornerAnnouncement =
			factory.createTransition();
		Transition transitionWating_For_ClimaxAnnouncementToWating_For_GoalAnnouncement =
			factory.createTransition();
		Transition transitionWating_For_4thCornerAnnouncementToWating_For_ClimaxAnnouncement =
			factory.createTransition();
		Transition transitionInitialStateToWating_For_StratAnnouncement =
			factory.createTransition();
		Transition transitionWating_For_GoalAnnouncementToWating_For_StratAnnouncement =
			factory.createTransition();

		//states setting

		//structure of states
		this.setInitialState(initialState);
		this.addState(wating_For_StratAnnouncement);
		this.addState(wating_For_4thCornerAnnouncement);
		this.addState(wating_For_ClimaxAnnouncement);
		this.addState(wating_For_GoalAnnouncement);

		//transitions setting
		transitionWating_For_StratAnnouncementToWating_For_4thCornerAnnouncement
			.setEvent(
			ChannelEvent.class);
		transitionWating_For_StratAnnouncementToWating_For_4thCornerAnnouncement
			.addAction(
			sayingStartEmotionAction);
		transitionWating_For_ClimaxAnnouncementToWating_For_GoalAnnouncement
			.setEvent(
			ChannelEvent.class);
		transitionWating_For_ClimaxAnnouncementToWating_For_GoalAnnouncement
			.setGuardCondition(
			isClimaxRanking);
		transitionWating_For_ClimaxAnnouncementToWating_For_GoalAnnouncement
			.addAction(
			sayingClimaxEmotion);
		transitionWating_For_4thCornerAnnouncementToWating_For_ClimaxAnnouncement
			.setEvent(
			ChannelEvent.class);
		transitionWating_For_4thCornerAnnouncementToWating_For_ClimaxAnnouncement
			.setGuardCondition(
			is4thCornerRanking);
		transitionWating_For_4thCornerAnnouncementToWating_For_ClimaxAnnouncement
			.addAction(
			saying4thCornerEmotion);
		transitionWating_For_GoalAnnouncementToWating_For_StratAnnouncement
			.setEvent(
			ChannelEvent.class);
		transitionWating_For_GoalAnnouncementToWating_For_StratAnnouncement
			.setGuardCondition(
			isGoalRanking);
		transitionWating_For_GoalAnnouncementToWating_For_StratAnnouncement
			.addAction(
			sayingGoalEmotion);

		//connection of transitions
		transitionWating_For_StratAnnouncementToWating_For_4thCornerAnnouncement
			.setSourceState(
			wating_For_StratAnnouncement);
		transitionWating_For_StratAnnouncementToWating_For_4thCornerAnnouncement
			.setTargetState(
			wating_For_4thCornerAnnouncement);
		transitionWating_For_ClimaxAnnouncementToWating_For_GoalAnnouncement
			.setSourceState(
			wating_For_ClimaxAnnouncement);
		transitionWating_For_ClimaxAnnouncementToWating_For_GoalAnnouncement
			.setTargetState(
			wating_For_GoalAnnouncement);
		transitionWating_For_4thCornerAnnouncementToWating_For_ClimaxAnnouncement
			.setSourceState(
			wating_For_4thCornerAnnouncement);
		transitionWating_For_4thCornerAnnouncementToWating_For_ClimaxAnnouncement
			.setTargetState(
			wating_For_ClimaxAnnouncement);
		transitionInitialStateToWating_For_StratAnnouncement.setSourceState(
			initialState);
		transitionInitialStateToWating_For_StratAnnouncement.setTargetState(
			wating_For_StratAnnouncement);
		transitionWating_For_GoalAnnouncementToWating_For_StratAnnouncement
			.setSourceState(
			wating_For_GoalAnnouncement);
		transitionWating_For_GoalAnnouncementToWating_For_StratAnnouncement
			.setTargetState(
			wating_For_StratAnnouncement);

	}

	/**
	*sayingClimaxEmotion
	*/
	protected abstract void sayingClimaxEmotion();
	/**
	*saying4thCornerEmotion
	*/
	protected abstract void saying4thCornerEmotion();
	/**
	*sayingGoalEmotion
	*/
	protected abstract void sayingGoalEmotion();
	/**
	*sayingStartEmotionAction
	*/
	protected abstract void sayingStartEmotionAction();
	/**
	*is4thCornerRanking
	*/
	protected abstract boolean is4thCornerRanking(Event e);
	/**
	*isGoalRanking
	*/
	protected abstract boolean isGoalRanking(Event e);
	/**
	*isClimaxRanking
	*/
	protected abstract boolean isClimaxRanking(Event e);
}
